/*
 * Copyright (C) 2004 by Jan Dubiec. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY JAN DUBIEC AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JAN DUBIEC
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * $Log: nuthwinit.c,v $
 * Revision 1.1  2004/03/16 16:48:26  haraldkipp
 * Added Jan Dubiec's H8/300 port.
 *
 */

/*
 * Hardware initialisation routine. It is called before .text and .data
 * sections are initialised. Bus controller and other essential hardware
 * setup code should be placed here.
 *
 * The code is partially based on an example distributed with H8 gcc.
 *
 * Author: Jan Dubiec <jdx@slackware.pl>
 *
 */

/* definition of the bus & wait-state controller register addresses */

#include <arch/arm.h>
#include <dev/s3c4510b_hw.h>
#include <dev/s3c4510b_irqreg.h>
#include <dev/s3c4510b_console.h>

void NutHWInit(unsigned long cpsr)
{
    // TO DO: add your additional hardware initialization code here.
}

void INT_EXCEPT(void)
{
    console_init();
    sm_puts("\r\n\r\n");
    sm_puts("SAMSUNG S3C4510B interrupt exception !!!!!\r\n\r\n");

    for(;;);
}

void INT_INVALID_CODE(unsigned long lr)
{
    console_init();
	sm_puts("SAMSUNG S3C4510B invalid code interrupt exception !!!!!\r\n");
	sm_printf("Exception PC = %d\r\n", lr);

    for(;;);
}
